module Text.HPaco.AST.AST where

import Text.HPaco.AST.Statement
import Text.HPaco.AST.Identifier (Identifier)

data AST =
    AST { astRootStatement :: Statement
        , astDefs :: [(Identifier,Statement)]
        , astDeps :: [String]
        }
        deriving (Show)

defAST :: AST
defAST =
    AST { astRootStatement = NullStatement
        , astDefs = []
        , astDeps = []
        }
